<?php
/**
 * @name KoinCurl curl wrapper
 * @copyright 2006 koinslot
 * @link http://www.koinslot.com
 * @author colson aka sumwatt aka xgrendel
 * @version .0.0.1 alpha
 *
 * @package curl wrapper component
 *
 * KoinSlot Unity is a package that serves as a unified payment validation and
 * feature interface for various online payment processors.
 *
 * This component was written to simplify using curl in an controller. There are some
 * notable points:
 *
 * Do NOT encapsulate your array keys in single or double quotes. The curl functions use
 * constants in PHP and thus, you need to do:
 *
 * $data[CURLOPT_URL] = 'http://www.someurl.com';
 *
 * If you do not follow the above advice, you will screw yourself and spend a few hours
 * wondering why Curl is returning a result of 'true' with a msg of 'false'.
 *
 */

class KoinCurlComponent extends Object
{

	/**
	 * This is the standard variable used by Cake to attache to the calling component
	 *
	 * @var boolean
	 */
	var $controller = true;

	/**
	 * This tells us wheter an error was generated by curl prior to making a call
	 *
	 * @var boolean
	 */
	var $result = false;

	/**
	 * This variable is used to hold the returned data from curl. It is a string.
	 *
	 * @var string - this is the results retrieved by curl
	 */
	var $msg;


	/**
	 * This is the initialization method.
	 *
	 * @param string  - $controller name
	 */
	function startup(&$controller)
    {
        $this->controller = $controller;
    }


    /**
     * This is the method that converts the passed in array to a curl call. It reutnrs
     * an array containing:
     *
     * msg = string
     * result = boolean
     *
     * @param array $data
     * @return array
     */
	function doRequest($data)
	{
		if(is_array(&$data))
		{

			$ch = curl_init();
			/**
			 * If we can do a quick check and the PHP version is >=5.1.4, then we
			 * can use the curl_setopt_array and just dump the array to the
			 */
			if(PHP_VERSION >= '5.3.0' && function_exists('curl_setopt_array'))
			{
				curl_setopt_array($ch, $data);
			}
			else
			{
				foreach($data as $k=>$v)
 				{
 					$k = up($k);
 					curl_setopt($ch, $k, $v);
 				}
			}
			/**


			 **/


			$request = curl_exec($ch);
			if (curl_error($ch))
			{
				$this->msg = curl_errno($ch) . " : " . curl_error($ch);
			}
			else
			{
				$this->msg = $request;
				$this->result = true;
			}
		}
		else
		{
			$this->msg = 'curl options must be in an array format, i.e. : $array[CURLOPT_URL] = "https://www.mysite.com";';
		}
		curl_close($ch);
		$results['Curl']['msg'] = $this->msg;
		$results['Curl']['result'] = $this->result;
		return $results;
	}


}
?>